summaryrefslogtreecommitdiffstats
path: root/ci/build.sh
diff options
context:
space:
mode:
Diffstat (limited to 'ci/build.sh')
-rwxr-xr-xci/build.sh74
1 files changed, 57 insertions, 17 deletions
diff --git a/ci/build.sh b/ci/build.sh
index f1333ce4..3531a657 100755
--- a/ci/build.sh
+++ b/ci/build.sh
@@ -8,17 +8,17 @@
# http://www.apache.org/licenses/LICENSE-2.0
##############################################################################
-set -e
+set -xe
display_usage ()
{
cat << EOF
$0 Builds the Apex OPNFV Deployment Toolchain
-usage: $0 [ -c cache_dir ] -r release_name [ --iso | --rpms ]
+usage: $0 [ -c cache_dest_dir ] -r release_name [ --iso | --rpms ]
OPTIONS:
- -c cache destination - directory of cached files, defaults to ./cache
+ -c cache destination - destination to save tarball of cache
-r release name/version of the build result
--iso build the iso (implies RPMs too)
--rpms build the rpms
@@ -30,12 +30,13 @@ build -c file:///tmp/cache -r dev123
EOF
}
-BUILD_BASE=$(readlink -e ../build/)
+APEX_ROOT=$(dirname $(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd))
CACHE_DEST=""
-CACHE_DIR="cache"
+CACHE_DIR="${APEX_ROOT}/.cache"
CACHE_NAME="apex-cache"
MAKE_TARGETS="images"
REQUIRED_PKGS="rpm-build python-docutils"
+RELEASE_RPM=""
parse_cmdline() {
while [ "${1:0:1}" = "-" ]
@@ -45,7 +46,7 @@ parse_cmdline() {
display_usage
exit 0
;;
- -c|--cache-dir)
+ -c|--cache-dest)
CACHE_DEST=${2}
shift 2
;;
@@ -63,11 +64,21 @@ parse_cmdline() {
echo "Buiding opnfv-apex RPMs"
shift 1
;;
+ --release-rpm )
+ RELEASE_RPM=" release-rpm"
+ echo "Buiding opnfv-apex RPMs"
+ shift 1
+ ;;
--debug )
debug="TRUE"
echo "Enable debug output"
shift 1
;;
+ --build-cache )
+ MAKE_TARGETS=""
+ echo "Building Cache"
+ shift 1
+ ;;
*)
display_usage
exit 1
@@ -78,11 +89,26 @@ parse_cmdline() {
}
run_make() {
- make $MAKE_ARGS -C ${BUILD_BASE} $1
+ make $MAKE_ARGS -C ${BUILD_DIRECTORY} $1
}
parse_cmdline "$@"
+if [ -z "$BUILD_DIRECTORY" ]; then
+ if [ -d "${APEX_ROOT}/build" ]; then
+ BUILD_DIRECTORY="${APEX_ROOT}/build"
+ else
+ echo "Cannot find build directory, please provide BUILD_DIRECTORY environment variable...exiting"
+ exit 1
+ fi
+elif [ ! -d "$BUILD_DIRECTORY" ]; then
+ echo "Provided build directory is invalid: ${BUILD_DIRECTORY} ...exiting"
+ exit 1
+fi
+
+# Add release rpm to make targets if defined
+MAKE_TARGETS+=$RELEASE_RPM
+
# Install build dependencies
for pkg in $REQUIRED_PKGS; do
if ! rpm -q $pkg > /dev/null; then
@@ -95,21 +121,29 @@ done
if [ -n "$RELEASE" ]; then MAKE_ARGS+="RELEASE=$RELEASE "; fi
-# Get the Old Cache
-if [ -n "$CACHE_DEST" ]; then
+# Get the Old Cache and build new cache history file
+if [[ -n "$CACHE_DEST" && -n "$MAKE_TARGETS" ]]; then
echo "Retrieving Cache"
if [ -f $CACHE_DEST/${CACHE_NAME}.tgz ]; then
echo "Cache found at ${CACHE_DEST}/${CACHE_NAME}.tgz"
- rm -rf $BUILD_BASE/$CACHE_DIR
- echo "Unpacking Cache to $BUILD_BASE"
- tar -xvzf $CACHE_DEST/${CACHE_NAME}.tgz -C ${BUILD_BASE}
+ rm -rf $CACHE_DIR
+ mkdir $CACHE_DIR
+ echo "Unpacking Cache to ${CACHE_DIR}"
+ tar -xvzf ${CACHE_DEST}/${CACHE_NAME}.tgz -C ${CACHE_DIR}
echo "Cache contents after unpack:"
- ls -l $BUILD_BASE/$CACHE_DIR
- elif [ ! -d $BUILD_BASE/$CACHE_DIR ]; then
- mkdir $BUILD_BASE/$CACHE_DIR
+ ls -al ${CACHE_DIR}
+ else
+ echo "No Cache Found"
fi
fi
+# Ensure the build cache dir exists
+if [ ! -d "$CACHE_DIR" ]; then
+ rm -rf ${CACHE_DIR}
+ echo "Creating Build Cache Directory"
+ mkdir ${CACHE_DIR}
+fi
+
# Conditionally execute RPM build checks if the specs change and target is not rpm or iso
if [[ "$MAKE_TARGETS" == "images" ]]; then
commit_file_list=$(git show --pretty="format:" --name-status)
@@ -123,6 +157,9 @@ if [[ "$MAKE_TARGETS" == "images" ]]; then
if [[ $commit_file_list == *build/rpm_specs/opnfv-apex-undercloud.spec* ]]; then
MAKE_TARGETS+=" undercloud-rpm-check"
fi
+ if [[ $commit_file_list == *build/rpm_specs/opnfv-apex-release.spec* ]]; then
+ MAKE_TARGETS+=" release-rpm-check"
+ fi
if [[ $commit_file_list == *build/rpm_specs/opnfv-apex-common.spec* ]]; then
MAKE_TARGETS+=" common-rpm-check"
fi
@@ -154,8 +191,11 @@ echo "Build Complete"
# Build new Cache
if [ -n "$CACHE_DEST" ]; then
echo "Building Cache"
- if [ ! -d $CACHE_DEST ]; then mkdir -p $CACHE_DEST; fi
- tar --atime-preserve --dereference -C $BUILD_BASE -caf $BUILD_BASE/${CACHE_NAME}.tgz $CACHE_DIR -C ${CACHE_DEST}/
+ ls -lah ${CACHE_DIR}
+ # ensure the destination exists
+ mkdir -p ${CACHE_DEST}
+ # roll the cache tarball
+ tar --atime-preserve --dereference -caf ${CACHE_DEST}/${CACHE_NAME}.tgz -C ${CACHE_DIR} .
if [ -f "${CACHE_DEST}/${CACHE_NAME}.tgz" ]; then
echo "Cache Build Complete"
else